package com.jetbyte.cache4;

import org.omg.CORBA.ORB;

import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContext;
import org.omg.CosNaming.NamingContextHelper;

import java.util.Properties;

public class Client 
{
   public static void main(String args[]) 
   {
      try
      {
         ORB orb = ORB.init(args, null);

         org.omg.CORBA.Object obj = GetObjectFromName(orb, "JetByte Test", "CacheTest");

         CacheTest test = CacheTestHelper.narrow(obj);

         String sql = "Select * from myTable where id = ";

         for (int i = 0; i < 10; ++i)
         {
            String[][] results = test.DoSelect(sql + i);
         
            displayResults(results);
         }

         for (int i = 0; i < 6; ++i)
         {
            String[][] results = test.DoSelect(sql + 5);
         
            displayResults(results);

            pause(10000);
         }

         pause(50000);

         displayResults(test.DoSelect(sql + 5));

         pause(60000);

         displayResults(test.DoSelect(sql + 0));

      }
      catch( Exception e )
      {
         e.printStackTrace(System.out);
      }
   }

   private static void displayResults(String[][] results)
   {
      for (int i = 0; i < results.length; ++i)
      {
         String line = "";

         for (int y = 0; y < results[i].length; ++y)
         {
            if (results[i][y].length() > 100)
            {
               line += "data too long - ";
            }
            else
            {
               line += results[i][y] + " - ";
            }
         }
      
         System.out.println(line);
      }
   }

   private static Object timer = new Object();

   private static void pause(long timeout)
   {
      try
      {
         synchronized(timer)
         {
            timer.wait(timeout);
         }
      }
      catch(InterruptedException e)
      {
      }
   }

   private static org.omg.CORBA.Object GetObjectFromName(
      ORB orb, 
      String contextName,
      String objectName) throws Exception
   {
      org.omg.CORBA.Object obj = orb.resolve_initial_references("NameService");

      NamingContext nc = NamingContextHelper.narrow(obj);

      if (nc == null) 
      {
         throw new Exception("Failed to narrow the root naming context.");
      }

      NameComponent[] name = new NameComponent[2];
      name[0] = new NameComponent(contextName, "JetByte Context"); 
      name[1] = new NameComponent(objectName, "Object"); 
	
      return nc.resolve(name);
   }
}

